import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "!WQYQPOOOkQPO'#CeOOQO'#Cj'#CjOOQO'#Cf'#CfQYQPOOOOQO,59P,59POrQPO,59POOQO-E6d-E6dOOQO1G.k1G.k",
  stateData: "y~O]OSPOS~ORQOSQOTQOUQOWPO~OVTO~PYOVWO~PYO",
  goto: "v_PPPPPPPPP`fPPPpXQOPSUQSOQUPTVSUXROPSU",
  nodeNames: "⚠ LineComment Program Keyword String Boolean Number ) ( Application",
  maxTerm: 14,
  nodeProps: [
    ["openedBy", 7,"("],
    ["closedBy", 8,")"]
  ],
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: "%z~RaX^!Wpq!Wrs!{st$ixy$wyz$|!Q![%R!]!^%Z!c!}%r#y#z!W$f$g!W#BY#BZ!W$IS$I_!W$I|$JO!W$JT$JU!W$KV$KW!W&FU&FV!W~!]Y]~X^!Wpq!W#y#z!W$f$g!W#BY#BZ!W$IS$I_!W$I|$JO!W$JT$JU!W$KV$KW!W&FU&FV!W~#OVOr!{rs#es#O!{#O#P#j#P;'S!{;'S;=`$c<%lO!{~#jOS~~#mRO;'S!{;'S;=`#v;=`O!{~#yWOr!{rs#es#O!{#O#P#j#P;'S!{;'S;=`$c;=`<%l!{<%lO!{~$fP;=`<%l!{~$lQ#Y#Z$r#h#i$r~$wOT~~$|OW~~%ROV~~%WPU~!Q![%R~%`SP~OY%ZZ;'S%Z;'S;=`%l<%lO%Z~%oP;=`<%l%Z~%wPR~!c!}%r",
  tokenizers: [0],
  topRules: {"Program":[0,2]},
  tokenPrec: 0
});

const NuformulaLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Application: delimitedIndent({ closing: ")", align: false })
            }),
            foldNodeProp.add({
                Application: foldInside
            }),
            styleTags({
                Keyword: tags.keyword,
                Boolean: tags.bool,
                String: tags.string,
                Number: tags.number,
                LineComment: tags.lineComment,
                "( )": tags.paren
            })
        ]
    }),
    languageData: {
        commentTokens: { line: ";" }
    }
});
function nuformula() {
    return new LanguageSupport(NuformulaLanguage);
}

export { NuformulaLanguage, nuformula };
